<template lang="pug">
div
  .row.text-grey-6(v-if='checkin && !checkin.questions') No questions have been configured.
  .row.items-center
    .col
      Question(
        v-if='currentQuestion',
        @update='updateSelection',
        :currentQuestion='currentQuestion',
        :sequence='checkin.currentQuestion',
        :response='getResponse()',
        :index='getIndex()'
      )
    .col-auto
      .row.items-between.q-col-gutter-sm
        .col-12.col-sm-auto
          q-btn(
            rounded,
            :disabled='(checkin && checkin.currentQuestion === 0) || (checkin && !checkin.currentQuestion)',
            color='primary',
            @click='prev()',
            label='Previous',
            style='width: 120px'
          )
        .col-12.col-sm-auto
          q-btn(
            rounded,
            :disabled='checkin && checkin.questions && (checkin.currentQuestion || 0) === checkin.questions.length - 1',
            @click='next()',
            color='primary',
            label='Next',
            style='width: 120px'
          )
</template>

<script>
import Question from './Question.vue';

export default {
  name: 'Dashboard',
  props: {
    firebase: {
      required: true,
    },
    context: {
      required: false,
    },
  },
  components: { Question },
  data: () => {
    return {
      checkin: null,
      answers: null,
    };
  },
  computed: {
    currentQuestion() {
      if (this.checkin && this.checkin.questions && this.checkin.questions.length > 0) {
        console.log(this.checkin);
        // if (this.checkin.currentQuestion)
        return this.checkin.questions[this.checkin.currentQuestion || 0];
        // return this.checkin[0];
      } else return null;
    },
  },
  methods: {
    getFirstOptions(options) {
      return Object.values(options)[0];
    },
    getLastOptions(options) {
      const tmp = Object.values(options);
      return tmp[tmp.length - 1];
    },
    getIndex() {
      return (this.checkin.currentQuestion || 0 + 1) + ' / ' + this.checkin.questions.length;
    },
    async updateSelection(value) {
      if (!this.checkin.currentQuestion) {
        this.checkin.currentQuestion = 0;
        await this.firebase
          .ref(`config/${this.context.meetingid}/current/currentState/plugins/checkin/currentQuestion`)
          .set(0);
      }

      //update with current question, and its answer
      const responseObj = {
        question: this.currentQuestion,
        recordedAt: Date.now(),
        response: value,
      };

      await this.firebase
        .ref(`data/topsCheckin/${this.context.meetingid}/${this.checkin.currentQuestion}`)
        .set(responseObj);

      await this.firebase
        .ref(
          `sequence/topsCheckin/${this.context.sequenceid}/${this.context.meetingid}/${this.checkin.currentQuestion}`,
        )
        .set(responseObj);

      await this.firebase
        .ref(
          `config/${this.context.meetingid}/current/currentState/plugins/checkin/responses/${this.checkin.currentQuestion}`,
        )
        .set(value);
    },
    async next() {
      if (!this.checkin.currentQuestion) this.checkin.currentQuestion = 0;

      await this.firebase
        .ref(`config/${this.context.meetingid}/current/currentState/plugins/checkin/currentQuestion`)
        .set(++this.checkin.currentQuestion);
    },
    async prev() {
      if (!this.checkin.currentQuestion) this.checkin.currentQuestion = 0;

      await this.firebase
        .ref(`config/${this.context.meetingid}/current/currentState/plugins/checkin/currentQuestion`)
        .set(--this.checkin.currentQuestion);
    },
    getResponse() {
      return this.checkin &&
        this.checkin.responses &&
        typeof this.checkin.responses[this.checkin.currentQuestion] != 'undefined'
        ? this.checkin.responses[this.checkin.currentQuestion]
        : Math.ceil(Object.values(this.currentQuestion.options).length / 2 - 1);
    },
  },
  watch: {
    firebase: {
      immediate: true,
      async handler() {
        // this.$rtdbBind('checkin', this.firebase.ref(`meta/checkin`));

        this.$rtdbBind(
          'checkin',
          this.firebase.ref(`config/${this.context.meetingid}/current/currentState/plugins/checkin`),
        );

        // console.log('this.conext.sequenceid: ', this.context.sequenceid);
      },
    },
  },
};
</script>

<style lang="scss" scoped></style>
